package fr.orsys.tp3.dao.impl;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;

import fr.orsys.tp3.dao.IEmployeDao;
import fr.orsys.tp3.domain.Employe;

public class EmployeDao2 implements IEmployeDao {

	private JdbcTemplate template;

	@Autowired
	public void setTemplate(JdbcTemplate template) {
		this.template = template;
	}

	@Override
	public Employe getEmployeById(int id) {
		final String EMPLOYE_SELECT = "select * from employe where id = ?";
		return template.queryForObject(EMPLOYE_SELECT, new Object[] { id }, EmployeDao2::createEmploye);
	}

	@Override
	public Employe getEmployeByLogin(String login) {
		final String EMPLOYE_SELECT = "select  * from employe where login = ?";
		return template.queryForObject(EMPLOYE_SELECT, new Object[] { login }, EmployeDao2::createEmploye);
	}

	@Override
	public void saveEmploye(Employe employe) {
		final String EMPLOYE_INSERT = "insert into employe (id, login, password, prenom, nom, email, role) values (?,?,?,?,?,?,?)";
		template.update(EMPLOYE_INSERT, new Object[] { employe.getId(), employe.getLogin(), employe.getPassword(), employe.getPrenom(), employe.getNom(), employe.getEmail(), employe.getRole() });
	}

	@Override
	public List<Employe> getAllEmployes() {
		final String EMPLOYE_SELECT = "select * from employe";
		return template.query(EMPLOYE_SELECT, EmployeDao2::createEmploye);
	}

	@Override
	public int getEmployesCount() {
		final String EMPLOYE_SELECT = "select count(*) from employe";
		return template.queryForObject(EMPLOYE_SELECT, new Object[] {}, Integer.class);
	}

	private static Employe createEmploye(ResultSet rs, int rowNum) throws SQLException {
		if(rs == null)
			return null;
		
		Employe emp = new Employe();
		emp.setEmail(rs.getString("email"));
		emp.setLogin(rs.getString("login"));
		emp.setNom(rs.getString("nom"));
		emp.setPrenom(rs.getString("prenom"));
		emp.setRole(rs.getString("role"));
		emp.setId(rs.getInt("id"));

		return emp;
	}

}
