package fr.orsys.tp3.service.impl;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import fr.orsys.tp3.dao.IEmployeDao;
import fr.orsys.tp3.domain.Employe;
import fr.orsys.tp3.service.IEmployeService;

@Service
public class EmployeService implements IEmployeService {
	
	private static final Logger logger = Logger.getLogger(EmployeService.class);

	private IEmployeDao employeDao;
	
	@PostConstruct
	public void onInit() {
		logger.info("The bean EmployeService has been created!");
	}
	
	@PreDestroy
	public void onDestroy() {
		logger.info("The bean EmployeService will be destroyed!");
	}

	@Override
	public Employe getEmployeById(int id) {
		return employeDao.getEmployeById(id);
	}

	@Override
	public Employe getEmployeByLogin(String login) {
		return employeDao.getEmployeByLogin(login);
	}

	@Override
	public void saveEmploye(Employe employe) {
		employeDao.saveEmploye(employe);
	}

	@Override
	public List<Employe> getAllEmployes() {
		return employeDao.getAllEmployes();
	}

	@Override
	public int getEmployesCount() {
		return employeDao.getEmployesCount();
	}

	@Autowired
	public void setEmployeDao(IEmployeDao employeDao) {
		this.employeDao = employeDao;
	}

}
